<template>
  <div
    class="ProfileLinksOld"
    :class="{ office: isOffice } "
    v-if="auth">

    <flink
      v-if="isOffice"
      href="/cabinet/wrench/profile"
      domain="main"
      class="item"
      :class="{ active: navActive==='profile'}">
      <span class="title">Настройка</span>
    </flink>

    <template v-if="auth.isOrganization">
      <flink
        href="/cabinet/price-upload/upload"
        domain="main"
        @click.native="openOrganizationLink($event); $ym('monolith_lk_link_click');"
        class="item desktopshow"
        :class="{ active: navActive==='price'}">
        <span :class="{ title: isOffice }">Мои прайсы</span>
      </flink>
      <flink
        v-if="!isOffice"
        href="/cabinet/price-upload/history"
        domain="main"
        @click.native="openOrganizationLink($event); $ym('monolith_lk_link_click');"
        class="item desktopshow upload-history">
        <span class="text">История загрузок</span>
      </flink>
    </template>

    <flink
      :href="warehouseLink"
      domain="main"
      @click.native="openWarehouseLink($event); $ym('monolith_lk_link_click');"
      class="item group-end desktopshow">
      <span :class="{ title: isOffice }">Мой склад</span>
    </flink>

    <template v-if="auth.isOrganization">
      <flink
        v-if="auth.organizationSended"
        @click.native="$ym('requests_in'); $ym('monolith_lk_link_click');"
        href="/cabinet/inbox"
        domain="main"
        class="item"
        :class="{ active: navActive==='inbox'}">
        <span class="icon">
          <img
            svg-inline
            src="~/assets/svg/icons/i-profile-response.svg">
        </span>
        <span :class="{ title: isOffice }">Входящие запросы</span>
        <span
          v-if="counters.countNewIncomingRequests > 0"
          class="counter">
          {{ counters.countNewIncomingRequests }}
        </span>
      </flink>
      <span
        v-else
        @click="showInfoOrganizationSended"
        class="item"
        :class="{ disabled : !isOffice && !counters.countIncomingRequests }">
        <span class="icon">
          <img
            svg-inline
            src="~/assets/svg/icons/i-profile-response.svg">
        </span>
        <span :class="{ title: isOffice }">Входящие запросы</span>
      </span>

      <flink
        href="/cabinet/outbox"
        domain="main"
        @click.native="$ym('requests_out'); $ym('monolith_lk_link_click');"
        class="item"
        :class="{ disabled : !isOffice && (counters.countOutgoingRequests === 0), active: navActive==='outbox' }">
        <span class="icon">
          <img
            svg-inline
            src="~/assets/svg/icons/i-profile-incomming-req.svg">
        </span>
        <span :class="{ title: isOffice }">Исходящие запросы</span>
        <span
          v-if="counters.countNewOutgoingRequests > 0"
          class="counter">
          {{ counters.countNewOutgoingRequests }}
        </span>
      </flink>

      <flink
        href="/cabinet/reviews/about-me"
        domain="main"
        @click.native="$ym('monolith_lk_link_click')"
        class="item desktopshow"
        :class="{ disabled : !isOffice && !counters.hasAboutMeReviews &&
        !counters.hasMyReviews }">
        <span :class="{ title: isOffice }">Отзывы</span>
        <span
          v-if="counters.countUnreadReviews > 0"
          class="counter">
          {{ counters.countUnreadReviews }}
        </span>
      </flink>
    </template>

    <template v-else>
      <flink
        href="/cabinet/outbox"
        domain="main"
        @click.native="$ym('my_requests'); $ym('monolith_lk_link_click');"
        class="item desktopshow"
        :class="{ disabled : !isOffice && !counters.countOutgoingRequests }">
        <span :class="{ title: isOffice }">Мои запросы</span>
        <span
          v-if="counters.countNewOutgoingRequests > 0"
          class="counter">
          {{ counters.countNewOutgoingRequests }}
        </span>
      </flink>
      <flink
        href="/cabinet/reviews/my"
        domain="main"
        @click.native="$ym('monolith_lk_link_click')"
        class="item group-end desktopshow"
        :class="{ disabled : !isOffice && !counters.hasMyReviews }">
        <span :class="{ title: isOffice }">Мои отзывы</span>
      </flink>
    </template>

    <flink
      v-if="!isOffice"
      href="/cart"
      rel="nofollow"
      domain="main"
      class="item desktopshow group-end my-cart"
      :class="{ disabled : $store.getters['cart/counter'] === 0 }">
      <span class="text">Корзина</span>
      <span
        v-if="$store.getters['cart/counter']"
        class="notification">{{ $store.getters['cart/counter'] }}</span>
    </flink>

    <flink
      href="/cabinet/check-auto"
      domain="main"
      @click.native="$ym('monolith_lk_link_click')"
      class="item desktopshow">
      <span :class="{ title: isOffice }">Проверки авто</span>
    </flink>

    <flink
      href="/cabinet/garage"
      domain="main"
      @click.native="$ym('monolith_lk_link_click')"
      class="item group-end desktopshow">
      <span :class="{ title: isOffice }">Гараж</span>
    </flink>

    <flink
      v-if="!isOffice"
      href="/cabinet/garage/parts-searched"
      domain="main"
      @click.native="$ym('monolith_lk_link_click')"
      class="item group-end mobilshow">
      <span class="icon">
        <img
          svg-inline
          src="~/assets/svg/icons/i-profile-search-history.svg">
      </span>
      <span class="text">Вы искали</span>
    </flink>

    <flink
      v-if="hasStat"
      href="/cabinet/statistics/clicks"
      domain="main"
      class="item group-end desktopshow"
      :class="{ active: navActive==='statistics'}">
      <span :class="{ title: isOffice }">Статистика</span>
    </flink>
  </div>
</template>

<script>
import { createNamespacedHelpers } from 'vuex';
import { SHOW as INFO_MODAL_SHOW } from '~/assets/js/store/infoModal/action-types';

const STORE_INFO_MODAL = createNamespacedHelpers('infoModal');
const STORE_USER = createNamespacedHelpers('user');

export default {
  name: 'ProfileLinks',
  props: {
    isOffice: { /* !isOffice это profileSidebar */
      type: Boolean,
      default: false,
    },
    navActive: {
      type: String,
      default: null,
    },
  },
  computed: {
    ...STORE_USER.mapState(['auth', 'counters']),
    ...STORE_USER.mapGetters(['hasStat']),
    warehouseLink() {
      if (this.auth.isOrganization) {
        return '/cabinet/warehouse/new-parts';
      }
      return '/cabinet/warehouse/do-parts';
    },
  },
  methods: {
    ...STORE_INFO_MODAL.mapActions({
      showInfoModal: INFO_MODAL_SHOW,
    }),
    openOrganizationLink(event) {
      if (!this.auth.organizationSended) {
        this.showInfoOrganizationSended();
        event.preventDefault();
        return false;
      }

      if (!this.auth.isOrganizationWithShop) {
        this.showInfoWithShop();
        event.preventDefault();
        return false;
      }

      return true;
    },
    openWarehouseLink(event) {
      if (!this.auth.isCompleteProfile) {
        this.showInfoCompleteProfile();
        event.preventDefault();
        return false;
      }
      if (this.auth.isOrganization) {
        return this.openOrganizationLink(event);
      }
      return true;
    },
    showInfoOrganizationSended() {
      this.showInfoModal({
        text: 'Необходимо заполнить <br/> данные организации',
        buttonText: 'Перейти к заполнению',
        buttonUrl: '/cabinet/wrench/organization-info#/new',
        buttonDomain: 'main',
        buttonVisibility: true,
      });
      this.$ym('lk_modal_shown');
    },
    showInfoWithShop() {
      this.showInfoModal({
        text: 'Необходимо добавить магазин',
        buttonText: 'Перейти к добавлению',
        buttonUrl: '/cabinet/wrench/organization-sto/shop/create/',
        buttonDomain: 'main',
        buttonVisibility: true,
      });
      this.$ym('lk_modal_shown');
    },
    showInfoCompleteProfile() {
      this.showInfoModal({
        text: 'Необходимо заполнить профиль',
        buttonText: 'Перейти к заполнению',
        buttonUrl: '/cabinet/wrench/profile',
        buttonDomain: 'main',
        buttonVisibility: true,
      });
      this.$ym('lk_modal_shown');
    },
  },
};
</script>

<style lang="postcss">
  .office .item {
    display: flex;
    flex-flow: row nowrap;
    justify-content: space-between;
    align-items: center;
    width: 100%;
    height: 3rem;
    padding: 1rem 1rem 1rem 1.5rem;
    cursor: pointer;
    border-bottom: 1px solid var(--border-color-main);

    &.active {
      background-color: var(--bg-main);
      pointer-events: none;
      font-weight: var(--font-weight-medium);
    }

    &:hover:not(.active) {
      > .title {
        color: var(--link-color);
      }
    }

    > .title {
      display: block;
      font-size: 0.875rem;
      line-height: 1.4;
      margin-right: 0.5rem;
      transition: 0.1s color var(--transition-easeOutQuad);
    }
  }

  .ProfileLinksOld {
    .item {
      display: flex;
      flex-flow: row nowrap;
      justify-content: flex-start;
      padding: .35rem 1rem;
      color: var(--color-main);
      cursor: pointer;
      white-space: nowrap;
      text-overflow: ellipsis;
      max-width: 100%;
      .icon {
        display: none;
      }
      &.bold {
        font-weight: 700;
        @media only screen and (max-width: 980px) {
          font-weight: normal;
        }
      }
      &.group-end {
        padding-bottom: 1rem;
      }
      &.disabled{
        opacity: .7;
        pointer-events: none;
      }
      @media only screen and (max-width: 980px) {
        display: flex;
        align-items: center;
        position: relative;
        color: #00405f;
        padding: 1em 2.5em 1em 4.5em;
        line-height: 1;
        font-size: 16px;
        &.disabled{
          pointer-events: none;
          opacity: .7;
        }
        &:after {
          display: block;
          content: "";
          position: absolute;
          bottom: 0;
          right: 2.5em;
          left: 4.5em;
          height: 1px;
          background: #e5e5e5;
        }
        .icon {
          display: inline-flex;
          position: absolute;
          left: 1.375rem;
          top: 50%;
          transition: all 1s ease-out;
          width: 2.125rem;
          height: 1.375rem;
          margin: 0 .6rem 0 0;
          transform: translateY(-50%)!important;
        }
        .svg {
          display: block;
          width: auto;
          height: 100%;
          margin: auto;
          fill: #4a7db4;
          &.icon-search-history {
            height: 103%;
          }
        }
      }
      .text{
        overflow: hidden;
        white-space: nowrap;
        text-overflow: ellipsis;
        flex: 1 1 100%;
      }
      .notification{
        color: #e13c3c;
        text-align: right;
      }
    }
  }
</style>
